#################################################################
# Tournament System Beta 0.1 for YaBB 2.1			#
# Created by: James Andrews (jam3z)				#
# ============================================================	#
# Enjoy this tournament mod, for all gaming communities		#
# which use the exellent YaBB forum software.			#
# =============================================================	#
# Visit my own gaiming community:				#
# www.time-clan.com						#
# =============================================================	#
# Please report any bugs/fixes for this mod:			#
# james.andrews89@ntlworld.com					#
# =============================================================	#
# Enjoy the Pwnage with your tournaments!!!			#
# Please note: I made this mod for myself. Therefore this mod   #
# is designed for my needs, and not everyone's.			#
# If you feel like something should be added, please let me	#
# know!								#
#################################################################
$tversion = "0.1 Beta";

if ($action eq 'detailedversion') { return 1; }
LoadLanguage("Display");

sub tournaments {
	my(@files, @players);
	my($file, $ladder, $appliedalready, $apply, $frameh, $ladderonpage, $tourlist, $ladderbutton, $applied, $count, $spaces);
	my $username = &MemberIndex("check_exist", $username);

	opendir(DIR, "$tournamentdir");
	@files = grep(/\.txt$/,readdir(DIR));
	closedir(DIR);
	if ( @files ) {
		my $ladderbutton = "";
		foreach $file (@files) {
			$number = $file;
			$number =~ s/[.txt]//g;
			require "$tournamentdir/$file";
			$id = $file;
			$id =~ s/[.txt]//g;
			foreach $player (@player) {
				$player =~ s/\A\s+//g;
				$player =~ s/\s+\Z//g;
				$count++;
			}	
			$list .=qq~
  			<tr>
    			<td height="30" class="windowbg" align="center"><a href="$boardurl/?action=tournamentview;id=$number">$name</a></td>
    			<td height="30" class="windowbg2" align="center">$num</td>
    			<td class="windowbg" align="center">$cost</td>
    			<td class="windowbg2" align="center">$prize</td>
  			</tr>
			~;
		}
	} else {
		$list .=qq~
  		<tr>
    		<td height="50" class="windowbg">
		<center>
      		There are no tournaments. 
    		</center>
    		</td>
  		</tr>
		~;
	}

	$yymain .=qq~
	<table width="700" border="0" cellspacing="1" cellpadding="0">
	<tr>
	<td height="30" colspan="4" align="center" class="sidetitle">Current Tournaments </td>
	</tr>
	<tr>
 	<td height="30" class="windowbg"><center>
     	<strong>Name</strong>
    	</center></td>
    	<td height="30" class="windowbg2"><center>
      	<strong>Spaces</strong>
    	</center></td>
    	<td class="windowbg"><center>
      	<strong>Cost<br />
      	</strong>(Credits)
    	</center>    </td>
    	<td class="windowbg2"><center>
      	<strong>Prize<br />
      	</strong>(Credits)
    	</center></td>
  	</tr>
	$list
	</table>~;
	$yytitle = "Tournaments";
	if($INFO{'action'} eq "tournaments") {
		&template;
	}
}

sub tournamentview {

	my(@files, @players);
	my($file, $ladder, $appliedalready, $apply, $frameh, $ladderonpage, $tourlist, $ladderbutton, $applied);
	my $username = &MemberIndex("check_exist", $username);

	$distourney = $INFO{'id'};
	require "$tournamentdir/$distourney.txt" or die "This tournament does not exist.\n"; 
	fopen(PLAYERS, "<$tournamentdir/players/$distourney.txt");
	@players = <PLAYERS>;
	close(PLAYERS);
	chomp @players;
	foreach $player (@players) {
		$player =~ s/\A\s+//g;
		$player =~ s/\s+\Z//g;
		&LoadUser($player);
		$playerlist .=qq~<a href="$boardurl/?action=viewprofile;username=$player">${$uid.$player}{'realname'}</a><br />~;
		$count++;
		if($username eq $player) {
				$applied = 1;
		}
	}
	$message = $description;
	require "$sourcedir/YaBBC.pl";
	&DoUBBC;
	$ubbcdescription = $message;
	$descriptiona   = qq~$ubbcdescription~;

	$spaces = $num-@players;

	my $group = "";
	chomp @groups;
	push(@groups, "Administrator");
	push(@groups, "Global Moderator");

	foreach $group (@groups) {
		$group =~ s/\A\s+//g;
		$group =~ s/\s+\Z//g;
		next unless $group;
		if( ${$uid.$username}{'position'} eq $group ) {
			$nogroup = 1;
		}
	}
	if($nogroup) {
		if($applied eq "1") {
				$apply .=qq~<b><center>You have been entered into this tournament</center></b>~;
		} else {
			$credits = ${$uid.$username}{'ext_18'};
			if($credits < $cost) {
				$more = $cost - $credits;
				$apply .=qq~<b><center>You need $more more credits to apply for this tournament.</center></b>~;
			} else {
				if($spaces eq "0") {
					$apply .=qq~<b>Tournament full</b>~;
				} else {
					$apply .=qq~
		          		<form id="apply" name="apply" method="post" action="$boardurl?action=tournamentapply">
				 		<input name="file" type="hidden" value="$distourney" />
				 		<center><input type="submit" name="Submit" value="Appy for this Tournament" /></center>
			  		</form>
			  		<br />~;
				}
			}
		}
	} else {
		$apply .=qq~<b><center>You are not in a required membergroup to play in this tournament.</center></b>~;
	}

	if($playerlist eq "") {
		$playerlist = "There are no players.";
	}
	if($num eq "4") {
		$fh = "400";
	} elsif( $num eq "8" ) {
		$fh = "600";
	} else {
			$fh = "400";
	}
	if( $started eq "1" ) {
		$ladder .=qq~<iframe src="$boardurl/tournaments/html/$html.html" height="$fh" width="550" border="1"></iframe>~;
	} else {
		$ladder .=qq~<center>There are $spaces spaces left</center>$apply~;
	}

	$yymain .=qq~
	<table width="700" border="0" cellspacing="0" cellpadding="0">
		 <tr>
		   <td height="30" class="sidetitle" align="center">$name</td>
		  </tr>
		  <tr>
		    <td><table width="700" border="0" cellspacing="1" cellpadding="0">
		      <tr>
		        <td height="30" class="windowbg"><center>
		          <strong>Name:</strong> <br />
		          $name 
		        </center></td>
		        <td height="30" class="windowbg2"><center>
		          <strong>Start:</strong> <br />
		          $start 
		        </center></td>
		        <td height="30" class="windowbg"><center>
		          <strong>Cost:</strong> $cost Credits. 
		              <br />
		        (You have ${$uid.$username}{'ext_18'} credits) 
		        </center></td>
		        <td height="30" class="windowbg2"><center>
		          Prize:<br />
		          $prize
		        </center></td>
		        <td height="30" class="windowbg"><center>
		          <strong>Tournament Leader:</strong><br />
		          ${$uid.$tadmin}{'realname'}
		          <br />
		        </center></td>
		        <td width="150" height="30" class="windowbg2"><center>
		          <strong>Current Applicants:</strong> 
		        </center></td>
		      </tr>
		      <tr>
		        <td colspan="5" class="windowbg"><br />
		          <strong>Description:</strong><br />
		          <br />
          		$descriptiona
		          <br />
		          <br />
			  $ladder
		          </td>
		        <td class="windowbg2"><center>
		          $playerlist<br />
		        </center></td>
		      </tr>
		    </table></td>
 		 </tr>	
		</table><br />
		~;


	$yytitle = "Tournament $name";
	&template;
}

sub apply {
	
	if($iamguest) {
		$yySetLocation = qq~$scripturl?action=login~;
		&redirectexit;
	} else {
	
		my($applied);
		my $username = &MemberIndex("check_exist", $username);
		my $tournamentfile = "$FORM{'file'}.txt";
		require "$tournamentdir/$tournamentfile";

		open(PLAYERS, '<', "$tournamentdir/players/$file");
		@players = <PLAYERS>;
		close PLAYERS;
		chomp @players;
	
		open(OUTPUT, ">>$tournamentdir/players/$tournamentfile") or die "Could not open $tournamentdir/players/$tournamentfile.\n"; 
		print OUTPUT "$username\n";
		close OUTPUT;

		eval 'use MIME::Lite;';
		&FromHTML($mbname);
		&FromHTML(${$uid.$username}{'email'});
		$msg = MIME::Lite->new(
                To      => ${$uid.$username}{'email'},
		From    => "$mbname Tournaments <$webmaster_email>",
		Subject => $name,
		Type    => 'multipart/mixed'
		);
		$msg->attach(
			Type => 'TEXT',
			Data => "Hello ${$uid.$username}{'realname'}, this email is confirmation of the tournament which you applied for.

			You have successfully been added to \"$name\" and you will recieve an email when the tournament starts ($start) giving you more information about this tournament and the fixtures. Just a quick reminder, you must obey the rules which have been set. If you break any of the rules then you will face a fine and disqualification. Also if you do not return a result to us, then you will face a fine.

			This tournaments prize is: $prize Credits!!!

			Thank you for entering this tournament ${$uid.$username}{'realname'}!
			Have fun, good luck!

			$mbname"
		);
		$msg->send();
		$credits = ${$uid.$username}{'ext_18'};
		${$uid.$username}{'ext_18'} = $credits-$cost;
		&UserAccount($username, "update");

		$yymain .=qq~ 
		<table width="400"  border="0" align="center" cellpadding="1" cellspacing="1">
 		<tr>
   		<td height="30" class="sidetitle"><div align="center">Tournament Application </div></td>
 		</tr>
 		<tr>
   		<td class="windowbg"><div align="center">
     		<p><br />
      		<strong><font color="#009900">Thank you ${$uid.$username}{'realname'} ($username).<br>
      		You have successfully been added to compete in this tournament.</font></strong></p>
     		<p align="left">$cost credits have been deducted from your account as a cost for this tournament.</p>
     		<p align="left">Additionally an email has been sent to ${$uid.$username}{'email'} with all the information about this tournament you are competing in.</p>
     		<p align="left">You will recieve another e-mail when the tournament has started, giving you all of the information about the tournament and the fixtures of who you will be playing. Please follow the instructions in the e-mails you recieve.</p>
		<p align="center">Have fun, good luck!</p>
   		</div></td>
  		</tr>
		</table>
		~;

		$yytitle = "Tournaments";
		&template;
		
	}
}

sub ladder {

	my $id = $INFO{'tourneyid'};
	my $file = "$id.txt";

	require "$tournamentdir/$file";
	require "$tournamentdir/players/$file";

	$yymain .=qq~
	<table width="100%"  border="0" cellspacing="0" cellpadding="0">
	<tr>
	<td width="100%" height="30" class="sidetitle" align="center">$name</td>
	</tr>
	<tr>
	<td class="windowbg"><blockquote>$description</blockquote></td>
	</tr>
	<tr>
	  <td><iframe src="$boardurl/tournaments/html/$html.html" width="100%" height="600" style="border:none">Your browser does not support iFrames. You can view the ladder <a href="#">here.</a></iframe></td>
	  </tr>
	<tr>
	  <td class="windowbg"><form id="score" name="score" method="post" action="$boardurl/?action=tournamentscore">
	    <center>
	        <input name="file" type="hidden" value="$file" />
	        <input name="report" type="submit" id="report" value="Report Your Score" />
	    </center>
	    </form></td>
	  </tr>
	</table>~;

	$yytitle = "$name Tournament Ladder";
	&template;

}

sub score {

	my $file = $FORM{'file'};
	require "$tournamentdir/$file";
	$yymain .=qq~<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  		<tr>
    		<td width="82" height="23"><img src="http://homepage.ntlworld.com/james.andrews89/ts/catleft.gif" /></td>
    		<td width="100%" background="http://homepage.ntlworld.com/james.andrews89/ts/catmid.gif"><center>
      		<strong>Report Your Score </strong>
    		</center>
      		<center>
		    </center>    </td>
		    <td width="82"><img src="http://homepage.ntlworld.com/james.andrews89/ts/catright.gif" /></td>
		  </tr>
		  <tr>
		    <td class="windowbg"></td>
		    <td class="windowbg">
			You can either let the admin know of the score by your own methed, or fill out this form to send and email to the admin.
			<form id="score" name="score" method="post" action="$boardurl?action=tournamentscore2">
			<input type="hidden" name="file" value="$file">
		    <center>
		      <br />
		      Your name: ${$uid.$username}{'realname'} ($username)<br />
		      <br />
		      Your Opponent: 
		    </center>
		    <label>
		    <center>
		      <br />
		      <input name="opponent" type="text" id="opponent" />
		    </center>
		    </label>
		    <center>
		      <br />
		      <br />
		      Details of your match:<br />
		    </center>
		    <label>
		    <center>
		      <textarea name="message" cols="28" rows="6" id="message"></textarea>
		    </center>
		    </label>
		    <center>
		      <br />
		    </center>
		    <label>
		    <center>
		      <input type="submit" name="Submit" value="Send Email" />
      		      <input type="hidden" name="tournament" value="$name" />
		    </center>
		    </label>
		    <center>
		      <br />
		    </center>
		    </form></td>
		    <td class="windowbg"></td>
		</tr>
		</table>~;
		&template;
}

sub score2 {

		$opponent = $FORM{'opponent'};
		$name = $FORM{'name'};
		$file = $FORM{'file'};
		$message = $FORM{'message'};

		eval 'use MIME::Lite;';
		$msg = MIME::Lite->new(
                	To      => ${$uid.$tadmin}{'email'},
			From    => "$mbname Tournaments <$webmaster_email>",
			Subject => "${$uid.$username}{'realname'} vs $opponent for tournament $name",
			Type    => 'multipart/mixed'
			);
		$msg->attach(
			Type => 'TEXT',
			Data => "Hello ${$uid.$tadmin}{'realname'}, player ${$uid.$username}{'realname'} ($username) has submitted a score. He/she sent this message:
				
				\"$message\"

				You will need to update this ladder in the admin center."
		);
		$msg->send();


		$yySetLocation = qq~$scripturl?action=tournaments~;
		&redirectexit;

}
